require "defines"

function round(num, idp)
	local mult = 10^(idp or 0)
	return math.floor(num * mult + 0.5) / mult
end

function arraylength(array)
	count = 0
	for _,_ in ipairs(array) do
		count = count+1
	end
	return count
end

function arrayGetIndex(array, item)
	for k,v in ipairs(array) do
		if v == item then return k end
	end
	return nil
end

function teleport(target_teleporter)
	if target_teleporter.name == "TeleporterEntity" then
		game.player.teleport({target_teleporter.position.x + 0.25, target_teleporter.position.y + 0.25})
	end
end

function isLinked(teleporter)
	state = false
	for k,v in ipairs(global.links) do
		if teleporter == global.links[k].a or teleporter == global.links[k].b then
			state = true
		end
	end
	return state
end

function findBside(teleporter)
	bside = nil
	for k,v in ipairs(global.links) do
		if teleporter == global.links[k].a then
			bside = global.links[k].b
		elseif teleporter == global.links[k].b then
			bside = global.links[k].a
		end
	end
	return bside
end

function breakLinks(someTeleporter)
	if isLinked(someTeleporter) then
		table.remove(global.links, arrayGetIndex(global.links, findBside(someTeleporter)))
		table.remove(global.links, arrayGetIndex(global.links, someTeleporter))
	end
end

game.on_init(
	function()
		global.links = global.links or {}
	end
)

game.on_load(
	function()
		global.links = global.links or {}
		for _,v in ipairs(game.players) do
			v.print("Simple Teleporters Mod v0.0.1 (Singleplayer version) loaded!")
		end
	end
)


set_a = false
set_b = false
allow_tp = true

game.on_event(defines.events.on_tick, 
	function()
		tp_range = { {game.player.position.x, game.player.position.y},{game.player.position.x, game.player.position.y} }
		next_teleporter = game.player.surface.find_entities_filtered{area = tp_range, name = "TeleporterEntity"}
		
		if arraylength(next_teleporter) >= 1 then
			allowed_range_x = next_teleporter[1].position.x + 0.4
			allowed_range_y = next_teleporter[1].position.y + 0.4
		
			if round(tonumber(game.player.position.x),0) <= allowed_range_x and round(tonumber(game.player.position.y),0) <= allowed_range_y then
				if arraylength(global.links) == 0 or isLinked(next_teleporter[1]) == false then
					--game.player.print("This teleporter is not linked!")
					if allow_tp == true then
						game.player.surface.create_entity({name="flying-text", position=game.player.position, text="This teleporter is not linked!", color={r = 1, g = 0, b = 0}})
						allow_tp = false
					end
				end
				if isLinked(next_teleporter[1]) then
					if allow_tp == true then
						teleport(findBside(next_teleporter[1]))
						allow_tp = false
					end
				end
			else
				if allow_tp == false then
					allow_tp = true
				end
			end
		end
	end
)

game.on_event(defines.events.on_built_entity, 
	function(event)
		if event.created_entity.name == "telelinker" then
			game.player.insert({name = "telelinker", count = 2})
			
			hitpos = event.created_entity.position
			hitrange = { {hitpos.x, hitpos.y},{hitpos.x, hitpos.y} }
			hittp = game.player.surface.find_entities_filtered{area = hitrange, name = "TeleporterEntity"}
			
			if arraylength(hittp) >= 1 then
				if set_a == false and set_b == false then
					temp_teleporter_a = hittp[1]
					--game.player.print("Teleporter A selected! Now click on the B side!")
					game.player.surface.create_entity({name="flying-text", position=game.player.position, text="A selected! Now click on the B side!", color={r = 1, g = 1, b = 0}})
					set_a = true
				elseif set_a == true and set_b == false then
					temp_teleporter_b = hittp[1]
					--game.player.print("Teleporter B selected! They are now linked!")
					game.player.surface.create_entity({name="flying-text", position=game.player.position, text="Connection established!", color={r = 1, g = 1, b = 0}})
					set_b = true
				end
				
				if set_a == true and set_b == true then
					global.links[arraylength(global.links)+1] = {a=temp_teleporter_a,b=temp_teleporter_b}
					set_a = false
					set_b = false
				end
			end

			event.created_entity.destroy()
		end
	end
)

game.on_event(defines.events.on_preplayer_mined_item,
	function(event)
	
		if event.entity.name == "TeleporterEntity" then
			if isLinked(event.entity) then
				breakLinks(event.entity)
			end
		end
	end
)